#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "histogram_internal.h"
#include "svg.h"
#include <curl/curl.h>
#include <sstream>
#include <string>


using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};

//
Input
input_data(istream& inp,bool promt) {
    size_t number_count;
    if(promt){
        cerr << "  : ";
    }
    inp >> number_count;

    Input in;
    in.numbers.resize(number_count);

    if(promt){
        cerr << " :\n";
    }
    for (size_t i = 0; i < number_count; i++) {
        inp >> in.numbers[i];
    }

    if(promt){
        cerr << "  : ";
    }
    inp >> in.bin_count;

    return in;
}

size_t
write_data(void* items, size_t item_size, size_t item_count, void* ctx) {
    stringstream* buffer = reinterpret_cast<stringstream*>(ctx);
    size_t data_size = item_size * item_count;
    (*buffer).write(reinterpret_cast<const char*>(items), data_size);
    return data_size;
}

Input
download(const string& address) {
    stringstream buffer;

    // TODO:  .
    CURL *curl = curl_easy_init();
      if(curl) {
        CURLcode res;
        curl_easy_setopt(curl, CURLOPT_URL, address.c_str());
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &buffer);
        res = curl_easy_perform(curl);
        curl_easy_cleanup(curl);
        if(res != 0){
            cerr << curl_easy_strerror(res);
            exit(1);
        }
      }

    return input_data(buffer, false);
}


int main(int argc, char* argv[]) {

    curl_global_init(CURL_GLOBAL_ALL);
    setlocale(LC_ALL, "Russian");

    Input input;
    if(argc > 1){
        input = download(argv[1]);
    }
    else{
        input = input_data(cin, true);
    }


    const auto bins = make_histogram(input.numbers, input.bin_count);
    show_histogram_svg(bins);

    return 0;
}
